uses crt;

Function HexB (B : Byte) : String;
Const
  HC : Array [0..15] of Char = '0123456789ABCDEF';
Begin
  HexB := HC[B shr 4] + HC[B and 15]
End;

const
  port_base     = $1f0; { hdd #0 }
  reg_data      = 0;    { r/w }
  reg_error     = 1;    { read }
  reg_wpc       = 1;    { write }
  reg_sec_count = 2;    { r/w }
  reg_sec_num   = 3;    { r/w }
  reg_cyl_lo    = 4;    { r/w }
  reg_cyl_hi    = 5;    { r/w }
  reg_drv_head  = 6;    { r/w }
  reg_status    = 7;    { read }
  reg_command   = 7;    { write }
  cmd_recalibr  = $10;
  cmd_read      = $20;
  cmd_write     = $30;
  cmd_verify    = $40;
  cmd_format    = $50;
  cmd_seek      = $70;

procedure cli; assembler; asm cli end;
procedure sti; assembler; asm sti end;

var
  buf : array [0..511] of byte;
  bufw : array [0..255] of word absolute buf;
  addr, val : word;

procedure outbuf;
var i,j:byte;
begin
  for j:=0 to 31 do
    for i:=0to 15 do begin
      gotoxy (2+i*3, 2+j);
      write (hexb(buf[j*16+i]));
      gotoxy (64+i, 2+j);
      if buf[j*16+i] >= 32 then
        write (char(buf[j*16+i]))
    end;
  writeln
end;

begin
  textmode (co80 or font8x8);
  fillchar (buf, 512, 0);

  { I dunno, but everything works properly with disabled ints too ;-}
{  cli;}

  { if drive is not ready, waiting }
  while port[port_base+reg_status] and $40 <> $40 do;

  { setting up all the drives/heads/cylinders/sectors }
  port[port_base+reg_sec_count] := 1;
  port[port_base+reg_sec_num] := 1;
  port[port_base+reg_cyl_lo] := 0;
  port[port_base+reg_cyl_hi] := 0;
  port[port_base+reg_drv_head] := $a0 or ((0 shl 4) or 01); {drv<<4|head}

  { writing a command }
  port[port_base+reg_command] := cmd_read;

  { if there is no data in the buffer yet, waiting }
  while port[port_base+reg_status] and $08 <> $08 do;

  { read 512 bytes (actually it reads 256 words) of a sector to the buffer }
  addr := 0;
  repeat
    bufw[addr] := portw[port_base+reg_data];
    inc (addr);
  until addr >= 256;

  { I think we should enable ints here ;-}
{  sti;}

  { displaying }
  outbuf;

  writeln ('error:  ',hexb(port[port_base+reg_error]),'h');
  writeln ('status: ',hexb(port[port_base+reg_status]),'h');

  { waiting for a key }
  write ('press any key...');
  readkey;
  textmode (co80)
end.
