

                        ; HDTEST.ASM module - direct IDE-HDC I/O test.

                                ; Assembly directives.
.seq                                    ; Sequential segment ordering.
nojumps                                 ; Don't write NOPs to code.
nosmart                                 ; No automatic optimization.
.386                                    ; Assume 386+ code is valid.

testhd segment use16 'CODE'     ; Test code segment.
                                        ; Initialize segment.
        assume  cs:testhd,ss:stackseg           ; Initial segment assumptions.

                                        ; Initialize registers.
 start: push    defdata defdata                 ; Put DEFDATA in DS and ES...
        pop     es ds                           ;    .
        assume  ds:defdata,es:defdata           ; ...done.

                                        ; Load bootsectors D:.
        mov     ax,0000h                        ; Cylinder number.
        mov     bx,0001h                        ; Head and sector numbers.
        mov     cx,0101h                        ; 1 sector from drive 1.
        mov     dx,offset iobuf                 ; Buffer offset.
        call    [ioread]                        ; Read the sector.
        mov     ax,0001h                        ; Cylinder number.
        mov     bx,0101h                        ; Head and sector numbers.
        mov     cx,0101h                        ; 1 sector from drive 1.
        mov     dx,offset iobuf+512             ; Buffer offset.
        call    [ioread]                        ; Read the sector.

                                        ; Terminate program.
        mov     ax,4C00h                        ; MS-DOS: Terminate Program.
        int     21h                             ; Call MS-DOS dispatcher.

                                        ; Clean up segment.
        assume  nothing                         ; Remove segment assumptions.
testhd ends                                     ; End of test code segment.

include idehdc.asm              ; Disk I/O segment.

defdata segment 'DATA'          ; Default data segment.
        iobuf   db      1024 dup (?)            ; I/O buffer.
defdata ends                                    ; End of default data segment.

stackseg segment stack 'STACK'  ; Stack segment.
        dw      0200h dup (?)                   ; Stack space (1024 bytes).
stackseg ends                                   ; End of stack segment.
end start                       ; Set entry point.
